## net.sf.saxon.option.xom
Class DocumentWrapper

    java.lang.Object
      net.sf.saxon.option.xom.NodeWrapper
          net.sf.saxon.option.xom.DocumentWrapper

All Implemented Interfaces:
  Source, PullEvent, DocumentInfo, Item, NodeInfo, ValueRepresentation, SiblingCountingNode, VirtualNode

    public class DocumentWrapper

extends NodeWrapper
implements DocumentInfo

The root node of an XPath tree. (Or equivalently, the tree itself).

This class is used not only for a document, but also for the root of a document-less tree fragment.

Author:
  Michael H. Kay, Wolfgang Hoschek (ported net.sf.saxon.jdom to XOM)

Field Summary
`protected String` `baseURI`
`protected Configuration` `config`
`protected long` `documentNumber`

Fields inherited from class net.sf.saxon.option.xom.NodeWrapper
`docWrapper, index, node, nodeKind`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DocumentWrapper(Node root, String baseURI, Configuration config)` Create a Saxon wrapper for a XOM root node

Method Summary
`Configuration` `getConfiguration()` Get the configuration previously set using setConfiguration
`long` `getDocumentNumber()` Get the unique document number for this document (the number is unique for all documents within a NamePool)
`NamePool` `getNamePool()` Get the name pool used for the names in this document
`int` `getTypeAnnotation()` Get the type annotation of this node, if any.
`String[]` `getUnparsedEntity(String name)` Get the unparsed entity with a given name
`Iterator<String>` `getUnparsedEntityNames()` Get the list of unparsed entities defined in this document
`Object` `getUserData(String key)` Get user data held in the document node.
`NodeInfo` `selectID(String id, boolean getParent)` Get the element with a given ID, if any
`void` `setConfiguration(Configuration config)` Set the configuration, which defines the name pool used for all names in this document.
`void` `setUserData(String key, Object value)` Set user data on the document node.
`NodeInfo` `wrap(Node node)` Wrap a node in the XOM document.

Methods inherited from class net.sf.saxon.option.xom.NodeWrapper

`atomize, compareOrder, copy, delete, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNodeKind, getParent, getPrefix, getRealNode, getRoot, getSiblingPosition, getStringValue, getStringValueCS, getSystemId, getTypedValue, getUnderlyingNode, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis, makeWrapper, makeWrapper, setSystemId`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`atomize, compareOrder, copy, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNodeKind, getParent, getPrefix, getRoot, getStringValue, getSystemId, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

Methods inherited from interface javax.xml.transform.Source
`setSystemId`

Methods inherited from interface net.sf.saxon.om.Item
`getStringValueCS, getTypedValue`

Field Detail

### config

    protected Configuration config

### baseURI

    protected String baseURI

### documentNumber

    protected long documentNumber

Constructor Detail

### DocumentWrapper

    public DocumentWrapper(Node root,
                           String baseURI,
                           Configuration config)

  Create a Saxon wrapper for a XOM root node

  Parameters:
    `root` - The XOM root node
    `baseURI` - The base URI for all the nodes in the tree
    `config` - The configuration which defines the name pool used for all names in this tree

Method Detail

### wrap

    public NodeInfo wrap(Node node)

  Wrap a node in the XOM document.

  Parameters:
    `node` - The node to be wrapped. This must be a node in the same document (the system does not check for this).
  Returns:
    the wrapping NodeInfo object

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the configuration, which defines the name pool used for all names in this document. This is always called after a new document has been created. The implementation must register the name pool with the document, so that it can be retrieved using getNamePool(). It must also call NamePool.allocateDocumentNumber(), and return the relevant document number when getDocumentNumber() is subsequently called.

  Parameters:
    `config` - The configuration to be used

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration previously set using setConfiguration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Overrides:
    `getConfiguration` in class `NodeWrapper`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the name pool used for the names in this document

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Overrides:
    `getNamePool` in class `NodeWrapper`
  Returns:
    the name pool in which all the names used in this document are registered

### getDocumentNumber

    public long getDocumentNumber()

  Get the unique document number for this document (the number is unique for all documents within a NamePool)

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Overrides:
    `getDocumentNumber` in class `NodeWrapper`
  Returns:
    the unique number identifying this document within the name pool

### selectID

    public NodeInfo selectID(String id,
                             boolean getParent)

  Get the element with a given ID, if any

  Specified by:
    `selectID` in interface `DocumentInfo`
  Parameters:
    `id` - the required ID value
    `getParent` -
  Returns:
    the element with the given ID, or null if there is no such ID present (or if the parser has not notified attributes as being of type ID).

### getUnparsedEntityNames

    public Iterator<String> getUnparsedEntityNames()

  Get the list of unparsed entities defined in this document

  Specified by:
    `getUnparsedEntityNames` in interface `DocumentInfo`
  Returns:
    an Iterator, whose items are of type String, containing the names of all unparsed entities defined in this document. If there are no unparsed entities or if the information is not available then an empty iterator is returned

### getUnparsedEntity

    public String[] getUnparsedEntity(String name)

  Get the unparsed entity with a given name

  Specified by:
    `getUnparsedEntity` in interface `DocumentInfo`
  Parameters:
    `name` - the name of the entity
  Returns:
    null: XOM does not provide access to unparsed entities

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any. Returns -1 for kinds of nodes that have no annotation, and for elements annotated as untyped, and attributes annotated as untypedAtomic.

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Overrides:
    `getTypeAnnotation` in class `NodeWrapper`
  Returns:
    the type annotation of the node.
  See Also:
    `Type`

### setUserData

    public void setUserData(String key,
                            Object value)

  Set user data on the document node. The user data can be retrieved subsequently using `getUserData(java.lang.String)`

  Specified by:
    `setUserData` in interface `DocumentInfo`
  Parameters:
    `key` - A string giving the name of the property to be set. Clients are responsible for choosing a key that is likely to be unique. Must not be null. Keys used internally by Saxon are prefixed "saxon:".
    `value` - The value to be set for the property. May be null, which effectively removes the existing value for the property.

### getUserData

    public Object getUserData(String key)

  Get user data held in the document node. This retrieves properties previously set using `setUserData(java.lang.String, java.lang.Object)`

  Specified by:
    `getUserData` in interface `DocumentInfo`
  Parameters:
    `key` - A string giving the name of the property to be retrieved.
  Returns:
    the value of the property, or null if the property has not been defined.

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.